byte Lshift[] = {3,3,2,2};

void setup() {
  Serial.begin(9600);
  pinMode (9, OUTPUT); // выход генератора

  //Регистр управления А таймера/счетчика1
  TCCR1A=0;
  //Регистр управления B таймера/счетчика1
  TCCR1B=0;
}


void loop() {

  static uint32_t UartFreq = 0; //Переменная для задания нужной чвастоты
  uint32_t compare = OCR1A;  //OCR1A - Регистры сравнения A выхода таймера/счетчика1
  uint16_t divider = 1;  //переменная коэфф. деления прескалера

  float freqency;

  if (Serial.available() > 0) { 
    UartFreq = Serial.parseInt(); //получаем значение частоты из сообщения UART

    if (UartFreq <= 0 || UartFreq > F_CPU/2) { //Проверяем допустимый диапазон значений частоты
      return; }

    compare = (F_CPU / UartFreq /2 /divider); //вычисляем нужное значение OCR


    for (byte i = 0; i < 4; i++) {

      if (compare > 65536) { 
        divider <<= Lshift[i];
        compare = F_CPU / UartFreq /2 /divider; }
        
      else {
        TCCR1B = (i + 1) | ( 1 << WGM12 ); 
        break; }  // CTC режим работы таймера
    } 

    OCR1A = compare-1; 
    TCCR1A = 1 << COM1A0;

// Вывод значения частоты обратно в UART в подтверждение 
//Следующие три строки можно закомментировать, эта информация
//не используется в программе управления на Delphi
    freqency = F_CPU / 2 / (OCR1A + 1) / divider;
    if (freqency <10000) { Serial.print(freqency, 0); Serial.println(" Hz "); }
    if (freqency >= 10000) { Serial.print(freqency / 1000, 3); Serial.println(" kHz"); }
 }
}
