﻿/*
 * Created by SharpDevelop.
 * User: MrShanti
 * Date: 10/17/2023
 * Time: 3:09 PM
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
 
using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;


namespace arduino_gen
{
	/// <summary>
	/// Description of MainForm.
	/// </summary>
	public partial class MainForm : Form
	{
		SerialPort mySerialPort = new SerialPort();
		int fstep = 1;
		
		public MainForm()
		{
			//
			// The InitializeComponent() call is required for Windows Forms designer support.
			//
			InitializeComponent();
			
			//
			// TODO: Add constructor code after the InitializeComponent() call.
			//
		}
		
		
		
		void MainFormLoad(object sender, EventArgs e)						
		{
			//Create com port object
			
			mySerialPort.BaudRate = 9600;
			mySerialPort.DataBits = 8;
			mySerialPort.PortName = "COM1";
			
			//Enumerate COM Ports
			cbPort.Items.Clear();
			
			foreach (string s in SerialPort.GetPortNames()) {
				cbPort.Items.Add(s);					
			}
			
			if (cbPort.Items.Count == 0) {
				cbPort.Text = "NO COM PORTS";
			}			
	
		}
		
		
		
		void BtnDisconnectClick(object sender, EventArgs e)
		{
			mySerialPort.Close();
			btnConnect.Enabled = true;
			btnDisconnect.Enabled = false;
			groupBox1.Enabled = false;
			ak1.Enabled = false;
			seFreq.Enabled = false;
			btnOK.Enabled = false;
			cbPort.Enabled = true;
			
		}
		
		
		void CbPortSelectedIndexChanged(object sender, EventArgs e)
		{
			btnConnect.Enabled = true;
			mySerialPort.PortName = cbPort.Text;
			
		}
		
		void BtnConnectClick(object sender, EventArgs e)
		{
			try {
				mySerialPort.Open();
			}
			catch (Exception ex){
																	//**!!!!!!!!!!!!!!!!!
				MessageBox.Show(" Port Open Error: " + mySerialPort.PortName + "\n" + ex);
				return;
			}
			
			btnConnect.Enabled = false;
			btnDisconnect.Enabled = true;
			groupBox1.Enabled = true;
			ak1.Enabled = true;
			seFreq.Enabled = true;
			btnOK.Enabled = true;
			cbPort.Enabled = false;
			
		}
		
		void send_data(int data){
			
			if ( !mySerialPort.IsOpen ) {
				return;
			}
			
			int v = data;
			if (v > 8000000) { v = 8000000; }
			else
			if (v < 1) { v = 1; } 
			string s = v.ToString();
			mySerialPort.WriteLine(s + "\n" + "\r");
		}
		
		void BtnOKClick(object sender, EventArgs e)
		{
			send_data(Convert.ToInt32(seFreq.Value));
		}
		
		
		void Rb1Click(object sender, EventArgs e)
		{
			if (rb1.Checked) {
				fstep = 1;
				ak1.Minimum = 1;
				ak1.Maximum = 100;
				ak1.TickFrequency  = 1;				
				ak1.Value = ak1.Maximum;
				
			} 
			
			else if (rb2.Checked) {
				fstep = 1;	
				ak1.Minimum = 1;
				ak1.Maximum = 1000;
				ak1.TickFrequency  = 1;
				ak1.Value = ak1.Maximum;
							
			}
			
			else if (rb3.Checked) {
				fstep = 10;		
				ak1.Minimum = 1;
				ak1.Maximum = 1000;
				ak1.TickFrequency  = 10;
				ak1.Value = ak1.Maximum;	
								
			}
			
			else if (rb4.Checked) {
				fstep = 1000;
				ak1.Minimum = 1;
				ak1.Maximum = 100;
				ak1.TickFrequency  = 1;
				ak1.Value = ak1.Maximum;	
										
			}
			
			else if (rb5.Checked) {
				fstep = 1000;	
				ak1.Minimum = 1;
				ak1.Maximum = 1000;
				ak1.TickFrequency  = 10;
				ak1.Value = ak1.Maximum;	
							
			}
			
			else if (rb6.Checked) {
				fstep = 100000;	
				ak1.Minimum = 1;
				ak1.Maximum = 80;
				ak1.TickFrequency  = 1;
				ak1.Value = ak1.Maximum / 2;	
								
			}
			
		seFreq.Value = ak1.Value * fstep;
		
		send_data(Convert.ToInt32(seFreq.Value));
				
		}
		
		
		void Ak1ValueChanged(object sender, EventArgs e)
		{
			seFreq.Value = ak1.Value * fstep;
		}
		
		
		void SeFreqValueChanged(object sender, EventArgs e)
		{
			decimal value;
			string f;
			
			if ((seFreq.Value > 999) & (seFreq.Value < 999999)) {
				f = " kHz";
				value = seFreq.Value / 1000;
			}	else
			
			if (seFreq.Value > 999999) {
				f = " MHz";
				value = seFreq.Value / 1000000;
				
			}	else {
				f = " Hz";
				value = seFreq.Value;
			}
			
			lbFreq.Text = value.ToString() + f;
				
				
		}
		
		
		void Ak1MouseUp(object sender, MouseEventArgs e)
		{
			send_data(Convert.ToInt32(seFreq.Value));	
		}
		
		void BtnUrlClick(object sender, EventArgs e)
		{
			string target= "https://www.musbench.com/all/";
			System.Diagnostics.Process.Start(target);	
		}
		
		
		void BtnDonateClick(object sender, EventArgs e)
		{
			string target= "https://musbench.com/all/donate/";
			System.Diagnostics.Process.Start(target);		
		}
		
		
				
		
	}
}
