unit uMainpas;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, uAtulKnob,
  Vcl.Samples.Spin, BCPort;

type
  TForm1 = class(TForm)
    btnConnect: TButton;
    btnDisconnect: TButton;
    cbPort: TComboBox;
    seFreq: TSpinEdit;
    ak1: TAtulKnob;
    rb1: TRadioButton;
    rb2: TRadioButton;
    rb3: TRadioButton;
    rb4: TRadioButton;
    rb5: TRadioButton;
    rb6: TRadioButton;
    lbFreq: TLabel;
    btnSend: TButton;
    BComPort1: TBComPort;
    procedure rb1Click(Sender: TObject);
    procedure ak1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure ak1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure seFreqChange(Sender: TObject);
  private
    { Private declarations }
    fStep: Integer;
    procedure SendData(const data: integer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.ak1Change(Sender: TObject);
begin
  seFreq.Value := ak1.Position * fStep;
  //abel1.Caption := IntToStr(ak1.Position);
end;

procedure TForm1.ak1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 SendData(seFreq.Value);
end;


procedure TForm1.btnConnectClick(Sender: TObject);
begin
  BComPort1.Port := cbPort.Text;
  if BComPort1.Open then begin
    btnConnect.Enabled := False;
    cbPort.Enabled := False;
    btnDisconnect.Enabled := True;
    btnSend.Enabled := True;
    btnConnect.Enabled := false;
    ak1.Enabled := True;
  end;
end;

procedure TForm1.btnDisconnectClick(Sender: TObject);
begin
  if BComPort1.Close then begin
    btnConnect.Enabled := True;
    cbPort.Enabled := True;
    btnDisconnect.Enabled := False;
    btnSend.Enabled := False;
    btnConnect.Enabled := True;
    ak1.Enabled := False;

  end;
end;

procedure TForm1.btnSendClick(Sender: TObject);
begin
  SendData(seFreq.Value);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  rb1Click(self);

  EnumComPorts(cbPort.Items);
  cbPort.ItemIndex := 0;




end;

procedure TForm1.rb1Click(Sender: TObject);
begin
  if rb1.Checked then begin
    ak1.Min := 1;
    ak1.Max := 100;
    fStep := 1;
    ak1.Position := 100;
    ak1.faceColor := $004040FF;
  end else
  if rb2.Checked then begin
    ak1.Min := 1;
    ak1.Max := 1000;
    fStep := 1;
    ak1.Position := 1000;
    ak1.faceColor := $0033A6FB;
  end else
  if rb3.Checked then begin
    ak1.Min := 1;
    ak1.Max := 1000;
    fStep := 10;
    ak1.Position := 1000;
    ak1.faceColor := $0010DEFC;
  end else
    if rb4.Checked then begin
    ak1.Min := 1;
    ak1.Max := 100;
    fStep := 1000;
    ak1.Position := 100;
    ak1.faceColor := $001BEF0A;
  end else
    if rb5.Checked then begin
    ak1.Min := 1;
    ak1.Max := 1000;
    fStep := 1000;
    ak1.Position := 1000;
    ak1.faceColor := $00FAA783;
  end else
    if rb6.Checked then begin
    ak1.Min := 1;
    ak1.Max := 80;
    fStep := 100000;
    ak1.Position := 40;
    ak1.faceColor := $00FA1616;
  end;

  SendData(seFreq.Value);


end;

procedure TForm1.seFreqChange(Sender: TObject);
var value: real;
    f : string;
begin

  if (seFreq.value > 999) and (seFreq.value < 999999) then
  begin
    f := ' kHz';
    Value := seFreq.value / 1000;
  end else

  if (seFreq.value > 999999) then
  begin
    f := ' MHz';
    Value := seFreq.value / 1000000;
  end else

  begin
    f := ' Hz';
    Value := seFreq.value;
  end;


  lbFreq.Caption := FormatFloat('#.###', Value) + f;
end;

procedure TForm1.SendData(const data: integer);
var s: string;
    v: integer;
begin
  if not BComPort1.Connected  then  exit;

  v := data;
  if v > 8000000 then v :=  8000000
  else if v < 1 then v :=  1;
  s  := IntToStr(v);
  BComPort1.WriteStr(s+chr(13));

end;

end.
